libqalculate-5.11.0: MathFunction Class Reference

libqalculate-5.11.0

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
MathFunction Class Referenceabstract

Abstract base class for mathematical functions. More...

`#include <Function.h>`

Inheritance diagram for MathFunction:

## Public Member Functions
| MathFunction (std::string name_, int argc_, int max_argc_=0, std::string cat_="", std::string title_="", std::string descr_="", bool is_active=true)
| MathFunction (const MathFunction *function)
virtual ExpressionItem * | copy () const =0
virtual void | set (const ExpressionItem *item)
virtual int | type () const
virtual int | subtype () const
virtual int | id () const
std::string | example (bool raw_format=false, std::string name_string="") const
void | setExample (std::string new_example)
bool | testArgumentCount (int itmp)
virtual MathStructure | calculate (const std::string &eq, const EvaluationOptions &eo=default_evaluation_options)
virtual MathStructure | parse (const std::string &eq, const ParseOptions &po=default_parse_options)
virtual int | parse (MathStructure &mstruct, const std::string &eq, const ParseOptions &po=default_parse_options)
virtual MathStructure | calculate (MathStructure &vargs, const EvaluationOptions &eo=default_evaluation_options)
virtual int | calculate (MathStructure &mstruct, const MathStructure &vargs, const EvaluationOptions &eo)
std::string | condition () const
std::string | printCondition ()
void | setCondition (std::string expression)
bool | testCondition (const MathStructure &vargs)
int | args () const
int | minargs () const
int | maxargs () const
int | args (const std::string &str, MathStructure &vargs, const ParseOptions &po=default_parse_options)
size_t | lastArgumentDefinitionIndex () const
Argument * | getArgumentDefinition (size_t index)
void | clearArgumentDefinitions ()
void | setArgumentDefinition (size_t index, Argument *argdef)
int | stringArgs (const std::string &str, std::vector< std::string > &svargs)
void | setDefaultValue (size_t arg_, std::string value_)
const std::string & | getDefaultValue (size_t arg_) const
void | appendDefaultValues (MathStructure &vargs)
MathStructure | produceVector (const MathStructure &vargs, int begin=-1, int end=-1)
MathStructure | produceArgumentsVector (const MathStructure &vargs, int begin=-1, int end=-1)
virtual bool | representsPositive (const MathStructure &, bool=false) const
virtual bool | representsNegative (const MathStructure &, bool=false) const
virtual bool | representsNonNegative (const MathStructure &, bool=false) const
virtual bool | representsNonPositive (const MathStructure &, bool=false) const
virtual bool | representsInteger (const MathStructure &, bool=false) const
virtual bool | representsNumber (const MathStructure &, bool=false) const
virtual bool | representsRational (const MathStructure &, bool=false) const
virtual bool | representsNonComplex (const MathStructure &, bool=false) const
virtual bool | representsReal (const MathStructure &, bool=false) const
virtual bool | representsComplex (const MathStructure &, bool=false) const
virtual bool | representsNonZero (const MathStructure &, bool=false) const
virtual bool | representsEven (const MathStructure &, bool=false) const
virtual bool | representsOdd (const MathStructure &, bool=false) const
virtual bool | representsUndefined (const MathStructure &) const
virtual bool | representsBoolean (const MathStructure &) const
virtual bool | representsNonMatrix (const MathStructure &) const
virtual bool | representsScalar (const MathStructure &) const
Public Member Functions inherited from ExpressionItem
| ExpressionItem (std::string cat_, std::string name_, std::string title_="", std::string descr_="", bool is_local=true, bool is_builtin=false, bool is_active=true)
virtual bool | destroy ()
bool | isRegistered () const
void | setRegistered (bool is_registered)
| For internal use.
virtual const std::string & | name (bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const std::string & | referenceName () const
virtual const ExpressionName & | preferredName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | preferredInputName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | preferredDisplayName (bool abbreviation=false, bool use_unicode=false, bool plural=false, bool reference=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const ExpressionName & | getName (size_t index) const
virtual void | setName (const ExpressionName &ename, size_t index=1, bool force=true)
virtual void | setName (std::string sname, size_t index, bool force=true)
virtual void | addName (const ExpressionName &ename, size_t index=0, bool force=true)
virtual void | addName (std::string sname, size_t index=0, bool force=true)
virtual size_t | countNames () const
virtual void | clearNames ()
virtual void | clearNonReferenceNames ()
virtual void | removeName (size_t index)
virtual size_t | hasName (const std::string &sname, bool case_sensitive=true) const
virtual size_t | hasNameCaseSensitive (const std::string &sname) const
virtual const ExpressionName & | findName (int abbreviation=-1, int use_unicode=-1, int plural=-1, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual const std::string & | title (bool return_name_if_no_title=true, bool use_unicode=false, bool(*can_display_unicode_string_function)(const char *, void *)=NULL, void *can_display_unicode_string_arg=NULL) const
virtual void | setTitle (std::string title_)
virtual const std::string & | description () const
virtual void | setDescription (std::string descr_)
virtual const std::string & | category () const
virtual void | setCategory (std::string cat_)
virtual bool | hasChanged () const
virtual void | setChanged (bool has_changed)
virtual bool | isLocal () const
virtual bool | setLocal (bool is_local=true, int will_be_active=-1)
virtual bool | isBuiltin () const
virtual bool | isApproximate () const
virtual void | setApproximate (bool is_approx=true)
virtual int | precision () const
virtual void | setPrecision (int prec)
virtual bool | isActive () const
virtual void | setActive (bool is_active)
virtual bool | isHidden () const
virtual void | setHidden (bool is_hidden)
virtual int | refcount () const
virtual void | ref ()
virtual void | unref ()
virtual void | ref (ExpressionItem *o)
virtual void | unref (ExpressionItem *o)
virtual ExpressionItem * | getReferencer (size_t index=1) const
virtual bool | changeReference (ExpressionItem *o_from, ExpressionItem *o_to)

## Protected Member Functions
bool | testArguments (MathStructure &vargs)
virtual MathStructure | createFunctionMathStructureFromVArgs (const MathStructure &vargs)
virtual MathStructure | createFunctionMathStructureFromSVArgs (std::vector< std::string > &svargs)

## Protected Attributes
MathFunction_p * | priv
int | argc
int | max_argc
std::vector< std::string > | default_values
size_t | last_argdef_index
std::string | scondition
std::string | sexample
Protected Attributes inherited from ExpressionItem
std::string | scat
std::string | stitle
std::string | sdescr
bool | b_local
bool | b_changed
bool | b_builtin
bool | b_approx
bool | b_active
bool | b_registered
bool | b_hidden
bool | b_destroyed
int | i_ref
int | i_precision
std::vector< ExpressionItem * > | v_refs
std::vector< ExpressionName > | names

## Detailed Description

Abstract base class for mathematical functions.

A mathematical function, subclassed from MathFunction, should at least reimplement calculate(MathStructure&, const MathStructure&, const EvaluationOptions&) and copy(), and preferably also the represents* functions. Argument definitions should be added in the constructor.

## Member Function Documentation

## ◆ args() [1/2]

int MathFunction::args | ( |  | ) | const

Returns the maximum number of arguments that the function accepts or -1 if the number of arguments is unlimited.

## ◆ args() [2/2]

int MathFunction::args | ( | const std::string & | str,
|  | MathStructure & | vargs,
|  | const ParseOptions & | po = default_parse_options )

Parses arguments from a text string and places them in a std::vector. The text string should be a comma separated list of arguments.

Parameters

  str | The argument string to parse.
  vargs | std::vector to store parsed arguments in.
  po | Parse options.

Returns
  The number of parsed arguments.

## ◆ calculate()

virtual int MathFunction::calculate | ( | MathStructure & | mstruct,
|  | const MathStructure & | vargs,
|  | const EvaluationOptions & | eo )
| virtual

The main function for subclasses to reimplement. Calculates a value from arguments in vargs and puts it in mstruct.

This function expects the number of arguments to be equal to the maximum number of arguments, and checked by the argument definitions.

If the return value is negative, then argument -(return value) has been evaluated in mstruct. If -(return value) is greater than max arguments, then mstruct is a std::vector of evaluated argument values.

Parameters

  [out] | mstruct | Structure that is set with the result of the calculation.
  | vargs | Arguments passed to the mathematical function.
  | eo | Evaluation options.

Returns
  1 if the calculation was successful.

Reimplemented in DataSet, and UserFunction.

## ◆ clearArgumentDefinitions()

void MathFunction::clearArgumentDefinitions | ( |  | ) |

Removes all argument definitions for the function.

## ◆ condition()

std::string MathFunction::condition | ( |  | ) | const

Returns the functions condition expression.

Returns
  The function's condition expression

## ◆ copy()

virtual ExpressionItem * MathFunction::copy | ( |  | ) | const
| pure virtual

Implements ExpressionItem.

## ◆ getArgumentDefinition()

Argument * MathFunction::getArgumentDefinition | ( | size_t | index | ) |

Returns the argument definition for an argument index.

Parameters

  index | Argument index.

Returns
  The argument definition for the index or NULL if no the argument was not defined for the index

## ◆ id()

virtual int MathFunction::id | ( |  | ) | const
| virtual

Reimplemented from ExpressionItem.

## ◆ lastArgumentDefinitionIndex()

size_t MathFunction::lastArgumentDefinitionIndex | ( |  | ) | const

Returns the index of the last argument definition.

Returns
  The index of the last argument definition

## ◆ maxargs()

int MathFunction::maxargs | ( |  | ) | const

Returns the maximum number of arguments that the function accepts or -1 if the number of arguments is unlimited.

## ◆ minargs()

int MathFunction::minargs | ( |  | ) | const

Returns the minimum number of arguments for the function.

## ◆ printCondition()

std::string MathFunction::printCondition | ( |  | ) |

Print the function's condition expression with argument names.

Returns
  The printed condition

## ◆ set()

virtual void MathFunction::set | ( | const ExpressionItem * | item | ) |
| virtual

Reimplemented from ExpressionItem.

## ◆ setArgumentDefinition()

void MathFunction::setArgumentDefinition | ( | size_t | index,
|  | Argument * | argdef )

Set the argument definition for an argument index.

Parameters

  index | Argument index.
  argdef | A newly allocated argument definition

## ◆ setCondition()

void MathFunction::setCondition | ( | std::string | expression | ) |

Sets the functions condition expression.

Parameters

  expression | The function's new condition expression

## ◆ subtype()

virtual int MathFunction::subtype | ( |  | ) | const
| virtual

Returns the subtype of the mathematical function, corresponding to which subsubclass the object belongs to.

Returns
  FunctionSubtype.

Implements ExpressionItem.

Reimplemented in DataSet, and UserFunction.

## ◆ testCondition()

bool MathFunction::testCondition | ( | const MathStructure & | vargs | ) |

Test if arguments fulfil the function's condition expression.

Parameters

  vargs | std::vector with arguments.

Returns
  true if the arguments fulfil the function's condition expression

## ◆ type()

virtual int MathFunction::type | ( |  | ) | const
| virtual

Returns the type of the expression item, corresponding to which subclass the object belongs to.

Returns
  ExpressionItemType.

Implements ExpressionItem.

The documentation for this class was generated from the following file:

- /build/libqalculate/src/libqalculate/libqalculate/Function.h